From cec4c0b87aedd817d7bd8c24ea3530482688624e Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Sun, 20 Jul 2014 11:37:56 +0200
Subject: [PATCH 2/2] WIP bluetooth userland

---
 Makefile_upgrade.inc                          |   16 +
 etc/Makefile                                  |    4 +-
 etc/bluetooth/Makefile                        |   15 +-
 etc/bluetooth/hcsecd.conf                     |   56 +
 etc/bluetooth/hosts                           |    6 +-
 etc/bluetooth/protocols                       |    7 +-
 etc/defaults/bluetooth.device.conf            |  111 +
 etc/defaults/rc.conf                          |   39 +-
 etc/mtree/BSD.include.dist                    |    6 +-
 etc/rc.d/Makefile                             |   13 +-
 etc/rc.d/bluetooth                            |  365 +++
 etc/rc.d/btconfig                             |   67 -
 etc/rc.d/bthcid                               |   19 -
 etc/rc.d/bthidd                               |   33 +
 etc/rc.d/hcsecd                               |   24 +
 etc/rc.d/sdpd                                 |   13 +-
 etc/rc.d/ubthidhci                            |   40 +
 include/Makefile                              |    5 +-
 lib/libbluetooth/Makefile                     |   34 +-
 lib/libbluetooth/bluetooth.3                  |  499 +++-
 lib/libbluetooth/bluetooth.c                  |   31 +-
 lib/libbluetooth/bluetooth.h                  |  215 +-
 lib/libbluetooth/dev.c                        |   95 +
 lib/libbluetooth/devaddr.c                    |  116 -
 lib/libbluetooth/hci.c                        |  734 +++++
 lib/libsdp/Makefile                           |   16 +-
 lib/libsdp/sdp-int.h                          |    8 +-
 lib/libsdp/sdp.3                              |   32 +-
 lib/libsdp/sdp.h                              |  429 +--
 lib/libsdp/search.c                           |   38 +-
 lib/libsdp/service.c                          |   65 +-
 lib/libsdp/session.c                          |   90 +-
 lib/libsdp/util.c                             |  102 +-
 share/examples/etc/README.examples            |    1 +
 share/man/man4/Makefile                       |    2 -
 share/man/man4/bluetooth.4                    |  392 ---
 share/man/man4/ng_bluetooth.4                 |  112 +
 share/man/man4/ng_bt3c.4                      |  129 +
 share/man/man4/ng_btsocket.4                  |  354 +++
 share/man/man4/ng_h4.4                        |  123 +
 share/man/man4/ng_hci.4                       |  387 +++
 share/man/man4/ng_l2cap.4                     |  422 +++
 share/man/man4/ng_ubt.4                       |  125 +
 share/man/man4/ubt.4                          |  149 -
 share/man/man4/ubtbcmfw.4                     |  108 +
 share/man/man4/usb.4                          |    5 +-
 share/man/man5/bluetooth.device.conf.5        |  186 ++
 share/man/man5/bluetooth.hosts.5              |   63 +
 share/man/man5/bluetooth.protocols.5          |   62 +
 share/man/man5/rc.conf.5                      |  158 +-
 sys/Makefile                                  |    2 +-
 sys/Makefile.modules                          |    2 +-
 sys/conf/files                                |   19 -
 sys/config/LINT64                             |    3 -
 sys/netbt/Makefile                            |   10 -
 sys/netbt/bluetooth.h                         |  158 -
 sys/netbt/bt_input.c                          |   41 -
 sys/netbt/bt_proto.c                          |  235 --
 sys/netbt/hci.h                               | 2579 -----------------
 sys/netbt/hci_event.c                         | 1086 -------
 sys/netbt/hci_ioctl.c                         |  301 --
 sys/netbt/hci_link.c                          | 1083 -------
 sys/netbt/hci_misc.c                          |  181 --
 sys/netbt/hci_socket.c                        | 1034 -------
 sys/netbt/hci_unit.c                          |  551 ----
 sys/netbt/l2cap.h                             |  493 ----
 sys/netbt/l2cap_lower.c                       |  205 --
 sys/netbt/l2cap_misc.c                        |  255 --
 sys/netbt/l2cap_signal.c                      | 1154 --------
 sys/netbt/l2cap_socket.c                      |  515 ----
 sys/netbt/l2cap_upper.c                       |  555 ----
 sys/netbt/rfcomm.h                            |  432 ---
 sys/netbt/rfcomm_dlc.c                        |  414 ---
 sys/netbt/rfcomm_session.c                    | 1697 -----------
 sys/netbt/rfcomm_socket.c                     |  514 ----
 sys/netbt/rfcomm_upper.c                      |  567 ----
 sys/netbt/sco.h                               |   90 -
 sys/netbt/sco_socket.c                        |  473 ---
 sys/netbt/sco_upper.c                         |  360 ---
 usr.bin/Makefile                              |    4 +-
 usr.bin/bthost/Makefile                       |    9 +
 usr.bin/bthost/bthost.1                       |  115 +
 usr.bin/bthost/bthost.c                       |  142 +
 usr.bin/btpin/Makefile                        |   10 -
 usr.bin/btpin/btpin.1                         |   92 -
 usr.bin/btpin/btpin.c                         |  151 -
 usr.bin/btsockstat/Makefile                   |   12 +
 usr.bin/btsockstat/btsockstat.1               |   83 +
 usr.bin/btsockstat/btsockstat.c               |  646 +++++
 usr.bin/rfcomm_sppd/Makefile                  |   10 +-
 usr.bin/rfcomm_sppd/rfcomm_sdp.c              |   72 +-
 usr.bin/rfcomm_sppd/rfcomm_sdp.h              |   40 -
 usr.bin/rfcomm_sppd/rfcomm_sppd.1             |  243 +-
 usr.bin/rfcomm_sppd/rfcomm_sppd.c             |  723 +++--
 usr.bin/sdpquery/Makefile                     |   14 -
 usr.bin/sdpquery/sdpquery.1                   |  210 --
 usr.bin/sdpquery/sdpquery.c                   |  152 -
 usr.bin/sdpquery/sdpquery.h                   |   43 -
 usr.sbin/Makefile                             |   15 +-
 usr.sbin/ath3kfw/Makefile                     |    8 +
 usr.sbin/ath3kfw/ath3kfw.8                    |   78 +
 usr.sbin/ath3kfw/ath3kfw.c                    |  297 ++
 usr.sbin/bcmfw/BCM-LEGAL.txt                  |    8 +
 usr.sbin/bcmfw/Makefile                       |    8 +
 usr.sbin/bcmfw/README                         |   22 +
 usr.sbin/bcmfw/bcmfw.8                        |  105 +
 usr.sbin/bcmfw/bcmfw.c                        |  308 ++
 usr.sbin/bt3cfw/Makefile                      |   11 +
 usr.sbin/bt3cfw/bt3cfw.8                      |   73 +
 usr.sbin/bt3cfw/bt3cfw.c                      |  228 ++
 usr.sbin/btconfig/Makefile                    |   10 -
 usr.sbin/btconfig/btconfig.8                  |  178 --
 usr.sbin/btconfig/btconfig.c                  | 1173 --------
 usr.sbin/bthcid/Makefile                      |   12 -
 usr.sbin/bthcid/bthcid.8                      |  173 --
 usr.sbin/bthcid/bthcid.c                      |  232 --
 usr.sbin/bthcid/bthcid.h                      |   91 -
 usr.sbin/bthcid/client.c                      |  346 ---
 usr.sbin/bthcid/config.c                      |  143 -
 usr.sbin/bthcid/hci.c                         |  355 ---
 usr.sbin/bthidcontrol/Makefile                |   15 +
 usr.sbin/bthidcontrol/bthidcontrol.8          |  102 +
 usr.sbin/bthidcontrol/bthidcontrol.c          |  215 ++
 usr.sbin/bthidcontrol/bthidcontrol.h          |   50 +
 usr.sbin/bthidcontrol/hid.c                   |  214 ++
 usr.sbin/bthidcontrol/sdp.c                   |  434 +++
 usr.sbin/bthidd/Makefile                      |   18 +
 usr.sbin/bthidd/bthid_config.h                |   70 +
 usr.sbin/bthidd/bthidd.8                      |  127 +
 usr.sbin/bthidd/bthidd.c                      |  266 ++
 usr.sbin/bthidd/bthidd.conf.sample            |   72 +
 usr.sbin/bthidd/bthidd.h                      |   93 +
 usr.sbin/bthidd/client.c                      |  256 ++
 usr.sbin/bthidd/hid.c                         |  408 +++
 usr.sbin/bthidd/kbd.c                         |  580 ++++
 usr.sbin/bthidd/kbd.h                         |   41 +
 usr.sbin/bthidd/lexer.l                       |  106 +
 usr.sbin/bthidd/parser.y                      |  475 +++
 usr.sbin/bthidd/server.c                      |  349 +++
 usr.sbin/bthidd/session.c                     |  184 ++
 usr.sbin/btpand/Makefile                      |   13 +
 usr.sbin/btpand/bnep.c                        |  755 +++++
 usr.sbin/btpand/bnep.h                        |   72 +
 usr.sbin/btpand/btpand.8                      |  240 ++
 usr.sbin/btpand/btpand.c                      |  293 ++
 usr.sbin/btpand/btpand.h                      |  212 ++
 usr.sbin/btpand/channel.c                     |  335 +++
 usr.sbin/btpand/client.c                      |  224 ++
 usr.sbin/btpand/event.c                       |  309 ++
 usr.sbin/btpand/event.h                       |  147 +
 usr.sbin/btpand/packet.c                      |  110 +
 usr.sbin/btpand/sdp.c                         |  209 ++
 usr.sbin/btpand/sdp.h                         |   38 +
 usr.sbin/btpand/server.c                      |  289 ++
 usr.sbin/btpand/tap.c                         |  167 ++
 usr.sbin/hccontrol/Makefile                   |   14 +
 usr.sbin/hccontrol/hccontrol.8                |  184 ++
 usr.sbin/hccontrol/hccontrol.c                |  322 ++
 usr.sbin/hccontrol/hccontrol.h                |   79 +
 usr.sbin/hccontrol/host_controller_baseband.c | 1877 ++++++++++++
 usr.sbin/hccontrol/info.c                     |  216 ++
 usr.sbin/hccontrol/link_control.c             |  960 ++++++
 usr.sbin/hccontrol/link_policy.c              |  305 ++
 usr.sbin/hccontrol/node.c                     |  607 ++++
 usr.sbin/hccontrol/send_recv.c                |  184 ++
 usr.sbin/hccontrol/status.c                   |  245 ++
 usr.sbin/hccontrol/util.c                     |  410 +++
 usr.sbin/hcsecd/Makefile                      |   13 +
 usr.sbin/hcsecd/hcsecd.8                      |  128 +
 usr.sbin/hcsecd/hcsecd.c                      |  446 +++
 .../hcsecd/hcsecd.conf                        |   45 +-
 .../bthcid.conf.5 => hcsecd/hcsecd.conf.5}    |   14 +-
 usr.sbin/hcsecd/hcsecd.h                      |   65 +
 usr.sbin/{bthcid => hcsecd}/lexer.l           |    6 +-
 usr.sbin/{bthcid => hcsecd}/parser.y          |  144 +-
 usr.sbin/hcseriald/Makefile                   |   11 +
 usr.sbin/hcseriald/hcseriald.8                |   86 +
 usr.sbin/hcseriald/hcseriald.c                |  268 ++
 usr.sbin/l2control/Makefile                   |   12 +
 usr.sbin/l2control/l2cap.c                    |  313 ++
 usr.sbin/l2control/l2control.8                |   97 +
 usr.sbin/l2control/l2control.c                |  220 ++
 usr.sbin/l2control/l2control.h                |   49 +
 usr.sbin/l2ping/Makefile                      |   11 +
 usr.sbin/l2ping/l2ping.8                      |  114 +
 usr.sbin/l2ping/l2ping.c                      |  292 ++
 usr.sbin/rfcomm_pppd/Makefile                 |   14 +
 usr.sbin/rfcomm_pppd/rfcomm_pppd.8            |  354 +++
 usr.sbin/rfcomm_pppd/rfcomm_pppd.c            |  471 +++
 usr.sbin/sdpcontrol/Makefile                  |   12 +
 usr.sbin/sdpcontrol/sdpcontrol.8              |  118 +
 usr.sbin/sdpcontrol/sdpcontrol.c              |  219 ++
 usr.sbin/sdpcontrol/sdpcontrol.h              |   49 +
 .../sdpquery => usr.sbin/sdpcontrol}/search.c |  293 +-
 usr.sbin/sdpd/Makefile                        |   11 +-
 usr.sbin/sdpd/bgd.c                           |   20 +-
 usr.sbin/sdpd/dun.c                           |   26 +-
 usr.sbin/sdpd/ftrn.c                          |   22 +-
 usr.sbin/sdpd/gn.c                            |  172 ++
 usr.sbin/sdpd/hf.c                            |  162 --
 usr.sbin/sdpd/hset.c                          |  143 -
 usr.sbin/sdpd/irmc.c                          |   24 +-
 usr.sbin/sdpd/irmc_command.c                  |   22 +-
 usr.sbin/sdpd/lan.c                           |   36 +-
 usr.sbin/sdpd/log.c                           |   10 +-
 usr.sbin/sdpd/log.h                           |   24 +-
 usr.sbin/sdpd/main.c                          |   26 +-
 usr.sbin/sdpd/nap.c                           |  209 ++
 usr.sbin/sdpd/opush.c                         |   24 +-
 usr.sbin/sdpd/panu.c                          |  172 ++
 usr.sbin/sdpd/profile.c                       |  160 +-
 usr.sbin/sdpd/profile.h                       |   19 +-
 usr.sbin/sdpd/provider.c                      |   57 +-
 usr.sbin/sdpd/provider.h                      |   52 +-
 usr.sbin/sdpd/sar.c                           |   22 +-
 usr.sbin/sdpd/scr.c                           |   11 +-
 usr.sbin/sdpd/sd.c                            |   63 +-
 usr.sbin/sdpd/sdpd.8                          |   45 +-
 usr.sbin/sdpd/server.c                        |  201 +-
 usr.sbin/sdpd/server.h                        |   44 +-
 usr.sbin/sdpd/sp.c                            |   23 +-
 usr.sbin/sdpd/srr.c                           |   14 +-
 usr.sbin/sdpd/ssar.c                          |  147 +-
 usr.sbin/sdpd/ssr.c                           |  235 +-
 usr.sbin/sdpd/sur.c                           |    9 +-
 usr.sbin/sdpd/uuid-private.h                  |    8 +-
 usr.sbin/sdpd/uuid.c                          |    8 +-
 227 files changed, 25064 insertions(+), 21687 deletions(-)
 create mode 100644 etc/bluetooth/hcsecd.conf
 create mode 100644 etc/defaults/bluetooth.device.conf
 create mode 100644 etc/rc.d/bluetooth
 delete mode 100644 etc/rc.d/btconfig
 delete mode 100644 etc/rc.d/bthcid
 create mode 100644 etc/rc.d/bthidd
 create mode 100644 etc/rc.d/hcsecd
 create mode 100644 etc/rc.d/ubthidhci
 create mode 100644 lib/libbluetooth/dev.c
 delete mode 100644 lib/libbluetooth/devaddr.c
 create mode 100644 lib/libbluetooth/hci.c
 delete mode 100644 share/man/man4/bluetooth.4
 create mode 100644 share/man/man4/ng_bluetooth.4
 create mode 100644 share/man/man4/ng_bt3c.4
 create mode 100644 share/man/man4/ng_btsocket.4
 create mode 100644 share/man/man4/ng_h4.4
 create mode 100644 share/man/man4/ng_hci.4
 create mode 100644 share/man/man4/ng_l2cap.4
 create mode 100644 share/man/man4/ng_ubt.4
 delete mode 100644 share/man/man4/ubt.4
 create mode 100644 share/man/man4/ubtbcmfw.4
 create mode 100644 share/man/man5/bluetooth.device.conf.5
 create mode 100644 share/man/man5/bluetooth.hosts.5
 create mode 100644 share/man/man5/bluetooth.protocols.5
 delete mode 100644 sys/netbt/Makefile
 delete mode 100644 sys/netbt/bluetooth.h
 delete mode 100644 sys/netbt/bt_input.c
 delete mode 100644 sys/netbt/bt_proto.c
 delete mode 100644 sys/netbt/hci.h
 delete mode 100644 sys/netbt/hci_event.c
 delete mode 100644 sys/netbt/hci_ioctl.c
 delete mode 100644 sys/netbt/hci_link.c
 delete mode 100644 sys/netbt/hci_misc.c
 delete mode 100644 sys/netbt/hci_socket.c
 delete mode 100644 sys/netbt/hci_unit.c
 delete mode 100644 sys/netbt/l2cap.h
 delete mode 100644 sys/netbt/l2cap_lower.c
 delete mode 100644 sys/netbt/l2cap_misc.c
 delete mode 100644 sys/netbt/l2cap_signal.c
 delete mode 100644 sys/netbt/l2cap_socket.c
 delete mode 100644 sys/netbt/l2cap_upper.c
 delete mode 100644 sys/netbt/rfcomm.h
 delete mode 100644 sys/netbt/rfcomm_dlc.c
 delete mode 100644 sys/netbt/rfcomm_session.c
 delete mode 100644 sys/netbt/rfcomm_socket.c
 delete mode 100644 sys/netbt/rfcomm_upper.c
 delete mode 100644 sys/netbt/sco.h
 delete mode 100644 sys/netbt/sco_socket.c
 delete mode 100644 sys/netbt/sco_upper.c
 create mode 100644 usr.bin/bthost/Makefile
 create mode 100644 usr.bin/bthost/bthost.1
 create mode 100644 usr.bin/bthost/bthost.c
 delete mode 100644 usr.bin/btpin/Makefile
 delete mode 100644 usr.bin/btpin/btpin.1
 delete mode 100644 usr.bin/btpin/btpin.c
 create mode 100644 usr.bin/btsockstat/Makefile
 create mode 100644 usr.bin/btsockstat/btsockstat.1
 create mode 100644 usr.bin/btsockstat/btsockstat.c
 delete mode 100644 usr.bin/rfcomm_sppd/rfcomm_sdp.h
 delete mode 100644 usr.bin/sdpquery/Makefile
 delete mode 100644 usr.bin/sdpquery/sdpquery.1
 delete mode 100644 usr.bin/sdpquery/sdpquery.c
 delete mode 100644 usr.bin/sdpquery/sdpquery.h
 create mode 100644 usr.sbin/ath3kfw/Makefile
 create mode 100644 usr.sbin/ath3kfw/ath3kfw.8
 create mode 100644 usr.sbin/ath3kfw/ath3kfw.c
 create mode 100644 usr.sbin/bcmfw/BCM-LEGAL.txt
 create mode 100644 usr.sbin/bcmfw/Makefile
 create mode 100644 usr.sbin/bcmfw/README
 create mode 100644 usr.sbin/bcmfw/bcmfw.8
 create mode 100644 usr.sbin/bcmfw/bcmfw.c
 create mode 100644 usr.sbin/bt3cfw/Makefile
 create mode 100644 usr.sbin/bt3cfw/bt3cfw.8
 create mode 100644 usr.sbin/bt3cfw/bt3cfw.c
 delete mode 100644 usr.sbin/btconfig/Makefile
 delete mode 100644 usr.sbin/btconfig/btconfig.8
 delete mode 100644 usr.sbin/btconfig/btconfig.c
 delete mode 100644 usr.sbin/bthcid/Makefile
 delete mode 100644 usr.sbin/bthcid/bthcid.8
 delete mode 100644 usr.sbin/bthcid/bthcid.c
 delete mode 100644 usr.sbin/bthcid/bthcid.h
 delete mode 100644 usr.sbin/bthcid/client.c
 delete mode 100644 usr.sbin/bthcid/config.c
 delete mode 100644 usr.sbin/bthcid/hci.c
 create mode 100644 usr.sbin/bthidcontrol/Makefile
 create mode 100644 usr.sbin/bthidcontrol/bthidcontrol.8
 create mode 100644 usr.sbin/bthidcontrol/bthidcontrol.c
 create mode 100644 usr.sbin/bthidcontrol/bthidcontrol.h
 create mode 100644 usr.sbin/bthidcontrol/hid.c
 create mode 100644 usr.sbin/bthidcontrol/sdp.c
 create mode 100644 usr.sbin/bthidd/Makefile
 create mode 100644 usr.sbin/bthidd/bthid_config.h
 create mode 100644 usr.sbin/bthidd/bthidd.8
 create mode 100644 usr.sbin/bthidd/bthidd.c
 create mode 100644 usr.sbin/bthidd/bthidd.conf.sample
 create mode 100644 usr.sbin/bthidd/bthidd.h
 create mode 100644 usr.sbin/bthidd/client.c
 create mode 100644 usr.sbin/bthidd/hid.c
 create mode 100644 usr.sbin/bthidd/kbd.c
 create mode 100644 usr.sbin/bthidd/kbd.h
 create mode 100644 usr.sbin/bthidd/lexer.l
 create mode 100644 usr.sbin/bthidd/parser.y
 create mode 100644 usr.sbin/bthidd/server.c
 create mode 100644 usr.sbin/bthidd/session.c
 create mode 100644 usr.sbin/btpand/Makefile
 create mode 100644 usr.sbin/btpand/bnep.c
 create mode 100644 usr.sbin/btpand/bnep.h
 create mode 100644 usr.sbin/btpand/btpand.8
 create mode 100644 usr.sbin/btpand/btpand.c
 create mode 100644 usr.sbin/btpand/btpand.h
 create mode 100644 usr.sbin/btpand/channel.c
 create mode 100644 usr.sbin/btpand/client.c
 create mode 100644 usr.sbin/btpand/event.c
 create mode 100644 usr.sbin/btpand/event.h
 create mode 100644 usr.sbin/btpand/packet.c
 create mode 100644 usr.sbin/btpand/sdp.c
 create mode 100644 usr.sbin/btpand/sdp.h
 create mode 100644 usr.sbin/btpand/server.c
 create mode 100644 usr.sbin/btpand/tap.c
 create mode 100644 usr.sbin/hccontrol/Makefile
 create mode 100644 usr.sbin/hccontrol/hccontrol.8
 create mode 100644 usr.sbin/hccontrol/hccontrol.c
 create mode 100644 usr.sbin/hccontrol/hccontrol.h
 create mode 100644 usr.sbin/hccontrol/host_controller_baseband.c
 create mode 100644 usr.sbin/hccontrol/info.c
 create mode 100644 usr.sbin/hccontrol/link_control.c
 create mode 100644 usr.sbin/hccontrol/link_policy.c
 create mode 100644 usr.sbin/hccontrol/node.c
 create mode 100644 usr.sbin/hccontrol/send_recv.c
 create mode 100644 usr.sbin/hccontrol/status.c
 create mode 100644 usr.sbin/hccontrol/util.c
 create mode 100644 usr.sbin/hcsecd/Makefile
 create mode 100644 usr.sbin/hcsecd/hcsecd.8
 create mode 100644 usr.sbin/hcsecd/hcsecd.c
 rename etc/bluetooth/bthcid.conf => usr.sbin/hcsecd/hcsecd.conf (63%)
 rename usr.sbin/{bthcid/bthcid.conf.5 => hcsecd/hcsecd.conf.5} (95%)
 create mode 100644 usr.sbin/hcsecd/hcsecd.h
 rename usr.sbin/{bthcid => hcsecd}/lexer.l (94%)
 rename usr.sbin/{bthcid => hcsecd}/parser.y (71%)
 create mode 100644 usr.sbin/hcseriald/Makefile
 create mode 100644 usr.sbin/hcseriald/hcseriald.8
 create mode 100644 usr.sbin/hcseriald/hcseriald.c
 create mode 100644 usr.sbin/l2control/Makefile
 create mode 100644 usr.sbin/l2control/l2cap.c
 create mode 100644 usr.sbin/l2control/l2control.8
 create mode 100644 usr.sbin/l2control/l2control.c
 create mode 100644 usr.sbin/l2control/l2control.h
 create mode 100644 usr.sbin/l2ping/Makefile
 create mode 100644 usr.sbin/l2ping/l2ping.8
 create mode 100644 usr.sbin/l2ping/l2ping.c
 create mode 100644 usr.sbin/rfcomm_pppd/Makefile
 create mode 100644 usr.sbin/rfcomm_pppd/rfcomm_pppd.8
 create mode 100644 usr.sbin/rfcomm_pppd/rfcomm_pppd.c
 create mode 100644 usr.sbin/sdpcontrol/Makefile
 create mode 100644 usr.sbin/sdpcontrol/sdpcontrol.8
 create mode 100644 usr.sbin/sdpcontrol/sdpcontrol.c
 create mode 100644 usr.sbin/sdpcontrol/sdpcontrol.h
 rename {usr.bin/sdpquery => usr.sbin/sdpcontrol}/search.c (77%)
 create mode 100644 usr.sbin/sdpd/gn.c
 delete mode 100644 usr.sbin/sdpd/hf.c
 delete mode 100644 usr.sbin/sdpd/hset.c
 create mode 100644 usr.sbin/sdpd/nap.c
 create mode 100644 usr.sbin/sdpd/panu.c

diff --git a/Makefile_upgrade.inc b/Makefile_upgrade.inc
index b1342bac73..0240b78f01 100644
--- a/Makefile_upgrade.inc
+++ b/Makefile_upgrade.inc
@@ -3916,6 +3916,22 @@ TO_REMOVE+=/usr/libexec/dhcpcd-hooks/02-dump
 TO_REMOVE+=/usr/lib/libtcplay.so.2
 TO_REMOVE+=/usr/include/pcap/export-defs.h
 TO_REMOVE+=/usr/share/mk/bsd.patch.mk
+TO_REMOVE+=/boot/kernel/netbt.ko
+TO_REMOVE+=/boot/kernel/ubt.ko
+TO_REMOVE+=/etc/bluetooth/bthcid.conf
+TO_REMOVE+=/etc/rc.d/btconfig
+TO_REMOVE+=/etc/rc.d/bthcid
+TO_REMOVE+=/usr/bin/btpin
+TO_REMOVE+=/usr/bin/sdpquery
+TO_REMOVE+=/usr/include/netbt
+TO_REMOVE+=/usr/sbin/btconfig
+TO_REMOVE+=/usr/sbin/bthcid
+TO_REMOVE+=/usr/share/man/man1/btpin.1.gz
+TO_REMOVE+=/usr/share/man/man1/sdpquery.1.gz
+TO_REMOVE+=/usr/share/man/man4/bluetooth.4.gz
+TO_REMOVE+=/usr/share/man/man4/ubt.4.gz
+TO_REMOVE+=/usr/share/man/man8/btconfig.8.gz
+TO_REMOVE+=/usr/share/man/man8/bthcid.8.gz
 
 .if !defined(WANT_INSTALLER)
 TO_REMOVE+=/usr/sbin/dfuibe_installer
diff --git a/etc/Makefile b/etc/Makefile
index 1140b61267..d9dfa227de 100644
--- a/etc/Makefile
+++ b/etc/Makefile
@@ -42,8 +42,8 @@ DIRS+=	lib/libssh usr.bin/openssl usr.bin/ssh usr.sbin/sshd
 #
 BIN2=	pccard_ether rc.suspend rc.resume
 
-DEFAULTS= compilers.conf devfs.conf make.conf periodic.conf \
-	  pfi.conf rc.conf uuids
+DEFAULTS= bluetooth.device.conf compilers.conf devfs.conf make.conf \
+	  periodic.conf pfi.conf rc.conf uuids
 
 MTREE=	BSD.include.dist BSD.root.dist BSD.usr.dist BSD.var.dist
 .if !defined(NOFSCHG)
diff --git a/etc/bluetooth/Makefile b/etc/bluetooth/Makefile
index d07efd58ab..1bd86841a3 100644
--- a/etc/bluetooth/Makefile
+++ b/etc/bluetooth/Makefile
@@ -1,16 +1,9 @@
-# $DragonFly: src/etc/bluetooth/Makefile,v 1.2 2008/02/12 21:36:19 hasso Exp $
+# $Id: Makefile,v 1.2 2003/10/21 22:22:27 max Exp $
+# $FreeBSD: head/etc/bluetooth/Makefile 151325 2005-10-14 15:26:23Z ru $
 
 FILESDIR=		/etc/bluetooth
-FILES=			protocols
-
-.if !exists(${DESTDIR}/etc/bluetooth/hosts)
-FILES+=			hosts
+FILES=			hcsecd.conf hosts protocols
+FILESMODE_hcsecd.conf=	600
 FILESMODE_hosts=	644
-.endif
-
-.if !exists(${DESTDIR}/etc/bluetooth/bthcid.conf)
-FILES+=			bthcid.conf
-FILESMODE_bthcid.conf=	600
-.endif
 
 .include <bsd.prog.mk>
diff --git a/etc/bluetooth/hcsecd.conf b/etc/bluetooth/hcsecd.conf
new file mode 100644
index 0000000000..6821d86540
--- /dev/null
+++ b/etc/bluetooth/hcsecd.conf
@@ -0,0 +1,56 @@
+# $Id: hcsecd.conf,v 1.1 2003/05/26 22:50:47 max Exp $
+# $FreeBSD: head/etc/bluetooth/hcsecd.conf 158726 2006-05-18 17:53:49Z emax $
+#
+# HCI security daemon configuration file
+#
+# Format:
+#
+# device {
+#	option	value ;
+# }
+#
+# Possible options and values
+#
+# Options	Values
+# ----------------------------------
+# bdaddr	xx:xx:xx:xx:xx:xx ;  	- remote device BD_ADDR
+# name 		"any char" ;		- to set user friendly device name
+# key		0x11223344 | nokey ;	- to set link key for the device
+# pin		"secret" | nopin ;	- to PIN code for the device
+#
+# Notes:
+#
+#	Currently there is no way to select keys/PIN code based on which
+#	local device received the request. Everything is based on remote
+#	device BD_ADDR.
+#
+#	"nokey"	means that no link key has been defined and we should
+#		send Link_Key_Negative_Reply command to the device.
+#
+#	"nopin"	means that no PIN code has been defined and we should
+#		send PIN_Code_Negative_Reply command to the device
+#
+
+# Default entry is applied if no better match found
+# It MUST have 00:00:00:00:00:00 as bdaddr
+device {
+	bdaddr	00:00:00:00:00:00;
+	name	"Default entry";
+	key	nokey;
+	pin	nopin;
+}
+
+device {
+	bdaddr	00:01:02:03:04:05;
+	name	"Dummy";
+	key	nokey;
+	pin	"0000";
+}
+
+device {
+	bdaddr	00:11:22:33:44:55;
+	name	"Dummy";
+	key	0x00112233445566778899aabbccddeeff; # 16 bytes key (hex string)
+	pin	nopin;
+}
+
diff --git a/etc/bluetooth/hosts b/etc/bluetooth/hosts
index 7ddfc5df0d..0c45efc86e 100644
--- a/etc/bluetooth/hosts
+++ b/etc/bluetooth/hosts
@@ -1,7 +1,5 @@
-# $DragonFly: src/etc/bluetooth/hosts,v 1.1 2008/01/03 13:35:20 hasso Exp $
-# $NetBSD: hosts,v 1.1 2006/06/19 15:44:35 gdamore Exp $
-# $Id: hosts,v 1.1 2006/06/19 15:44:35 gdamore Exp $
-# $FreeBSD: /repoman/r/ncvs/src/etc/bluetooth/hosts,v 1.2 2005/11/10 19:09:22 emax Exp $
+# $Id: hosts,v 1.1 2003/05/21 17:48:40 max Exp $
+# $FreeBSD: head/etc/bluetooth/hosts 152286 2005-11-10 19:09:22Z emax $
 #
 # Bluetooth Host Database
 #
diff --git a/etc/bluetooth/protocols b/etc/bluetooth/protocols
index 396b55014d..99029b2374 100644
--- a/etc/bluetooth/protocols
+++ b/etc/bluetooth/protocols
@@ -1,7 +1,5 @@
-# $DragonFly: src/etc/bluetooth/protocols,v 1.1 2008/01/03 13:35:20 hasso Exp $
-# $NetBSD: protocols,v 1.1 2006/06/19 15:44:35 gdamore Exp $
-# $Id: protocols,v 1.1 2006/06/19 15:44:35 gdamore Exp $
-# $FreeBSD: /repoman/r/ncvs/src/etc/bluetooth/protocols,v 1.2 2005/11/10 19:09:22 emax Exp $
+# $Id: protocols,v 1.2 2003/05/21 22:17:14 max Exp $
+# $FreeBSD: head/etc/bluetooth/protocols 152286 2005-11-10 19:09:22Z emax $
 #
 # Bluetooth Protocol/Service Multiplexor (PSM) names and numbers
 #
@@ -21,3 +19,4 @@ upnp             21  UPnP          # See ESDP, Bluetooth SIG
 avctp            23  AVCTP         # Audio/Video Control Transport Protocol
 avdtp            25  AVDTP         # Audio/Video Distribution Transport Protocol
 udi-c-plane      29  UDI-C-Plane   # Unrestricted Digital Information Profile
+
diff --git a/etc/defaults/bluetooth.device.conf b/etc/defaults/bluetooth.device.conf
new file mode 100644
index 0000000000..9d91d45352
--- /dev/null
+++ b/etc/defaults/bluetooth.device.conf
@@ -0,0 +1,111 @@
+# Copyright (c) 2005 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD: head/etc/defaults/bluetooth.device.conf 179360 2008-05-27 17:46:32Z emax $
+
+# The authentication_enable parameter controls if the device requires to
+# authenticate the remote device at connection setup. At connection setup,
+# only the devices with the authentication_enable parameter enabled will
+# try to authenticate the other device.
+#
+# Possible values:
+#
+# NO  or 0	authentication disabled (default);
+# YES or 1	authentication enabled.
+
+# authentication_enable="NO"
+
+# The class parameter is used to indicate the capabilities of the device to
+# other devices.
+#
+# For more details see "Assigned Numbers - Bluetooth Baseband" document
+#
+# Possible value:
+#
+# xx:xx:xx	where xx is a hex number
+
+# class="ff:01:0c"
+
+# The connectable parameter controls whether or not the device should
+# periodically scan for page attempts from other devices.
+#
+# Possible values:
+#
+# NO  or 0	do not scan for page attempts;
+# YES or 1	scan for page attempts (default).
+
+# connectable="YES"
+
+# The discoverable parameter controls whether or not the device should
+# periodically scan for inquiry requests from other devices.
+#
+# Possible values:
+#
+# NO  or 0	do not scan for inquiry requests;
+# YES or 1	scan for inquiry requests (default).
+
+# discoverable="YES"
+
+# The encryption_mode parameter controls if the device requires encryption
+# to the remote device at connection setup. At connection setup, only the
+# devices with the authentication_enable parameter enabled and encryption_mode
+# parameter enabled will try to encrypt the connection to the other device.
+#
+# Possible values:
+#
+# NONE or 0	encryption disabled (default);
+# P2P  or 1	encryption only for point-to-point packets;
+# ALL  or 2	encryption for both point-to-point and broadcast packets.
+
+# encryption_mode="NONE"
+
+# HCI node debug level. Higher values mean more verbose output.
+#
+# Possible values: 0 - 4
+
+# hci_debug_level="3"
+
+# L2CAP node debug level. Higher values mean more verbose output.
+#
+# Possible values: 0 - 4
+
+# l2cap_debug_level="3"
+
+# The local_name parameter provides the ability to modify the user friendly
+# name for the device.
+
+# local_name="My device"
+
+# The role_switch parameter controls whether the local device should perform
+# role switch. By default, if role switch is supported, the local device will
+# try to perform role switch and become Master on incoming connection. Some
+# devices do not support role switch and thus incoming connections from such
+# devices will fail. If role switch is disabled then accepting device will
+# remain Slave.
+#
+# NO  or 0	do not perform role switch;
+# YES or 1	perform role switch (default).
+
+# role_switch="YES"
+
